(defun c:t1 ()
	(setvar "CMDECHO" 0)
	(setvar "BLIPMODE" 0)
	(setq pontos2d (getvar "osmode"))
	(setq pontos3d (getvar "3dosmode"))
	(setvar "osmode" 0)
	(setvar "3dosmode" 0)
	(setq largura (getreal "\nIndique o comprimento total (em x) " ))
	(setq comprimento (getreal "\nIndique a largura total (em y) " ))
	(command "ucs" (getpoint "\nIndique o ponto de inserção: ") "")
	;colunas/pilares
		(command "rectangle" (list 0.02 0.02) (list 0.27 0.27))
		(ext 2.7)
		(command "array" (entlast) "" "R" 3 4 (/ (- comprimento 0.30) 2) (/ (- largura 0.30) 3))
		
	;pavimento
	(command "rectangle" (list 0 0) 
						(list largura comprimento)
						)
	(command "extrude" (entlast) "" -0.2)
	
	
	;paredes exteriores
	(command "rectangle" (list 0 0) 
						(list largura comprimento)
						)
	(reg)
	(setq e1 (entlast))
	(command "rectangle" (list 0.3 -0.3) 
						(list (- largura 0.3) (- comprimento 0.3))
						)
	(reg)
	(setq e2 (entlast))
	(command "subtract" e1 "" e2 "")
	(setq paredes (entlast))
	
	;vão porta exterior
	(command "rectangle" (list (setq val1 (alea (* largura 0.4) (* largura 0.6))) (/ comprimento 2)) (list (+ val1 0.9) (+ comprimento 1)))	
	(reg)
	(setq vporta (entlast))
	
	(command "subtract" paredes "" vporta "")
	
	;desenha a altura das paredes exteriores
	(ext 2.7)
	
	;desenho da wc
	(command "rectangle" (list 0.2 (setq val3 (alea (/ comprimento 2.1) (/ comprimento 2.1)))) 
    					 (list (setq val4 (alea (/ largura 2.75) (/ largura 2.75))) (- comprimento 0.3))					 
						 )
	(reg)
	(setq e3 (entlast))
	(command "rectangle" (list 0.3 (+ val3 0.2)) 
						 (list (- val4 0.2) (- comprimento 0.2)))
	(reg)
	(setq e4 (entlast))
	(command "subtract" e3 "" e4 "")
	(setq wc (entlast))	
	
	;desenho do vão da porta Wc
	(command "rectangle" (list 0.5 (setq val5 (- comprimento 0.4))) (list (- largura 0.5) (- val5 0.80)))
	(reg)DISR

	(command "subtract" wc "" (entlast) "")
		(setq wc (entlast))	

;unir as paredes
	(command "union" wc paredes e5 "")
	
	;desenha a altura das paredes
	(ext 2.7)
	
	;desenhar porta exterior
	(command "color" 1)
	(command "rectangle" (list val1 (- comprimento 0.3)) (list (+ val1 0.9) (- comprimento 0.25)))
	(reg)
	(ext 2.2)
	(command "color" "bylayer")
	
	;desenhar porta wc
	(command "color" 2)
	(command "rectangle" (list (- val4 0.2) val5) (list (+ (- val4 0.2) 0.05) (- val5 0.65)))
	(reg)
	(ext 2.2)
	(command "color" "bylayer")
	
	;desenhar a janela 1
	(command "3dpoly"   (list 0.3 0.02 0)
						(list 0.3 0.02 2.7)
						(list (- (/ largura 3) 0.125) 0.02 2.7)
						(list (- (/ largura 3) 0.125) 0.02 0)
						"cl")
	(setq caminho (entlast))
	(command "rectangle" (list 0.3 0.02 1.5)
							(list 0.35 0.07 1.5)
							)
	(setq e6 (entlast))
		(command "color" 5)	
	(command "extrude" e6 "" "p" caminho )
		(command "color" "bylayer")		
		
;desenhar a janela 2
	(command "3dpoly"   (list (+ (/ largura 1.5) 0.125) 0.02 0)
						(list (+ (/ largura 1.5) 0.125) 0.02 2.7)
						(list (- largura 0.3) 0.02 2.7)
						(list (- largura 0.3) 0.02 0)
						"cl")
	(setq caminho (entlast))
	(command "rectangle" (list (+ (/ largura 1.5) 0.125) 0.02 1.5)
						 (list (+ (/ largura 1.5) 0.175) 0.07 1.5)
							)
	(setq e6 (entlast))
		(command "color" 5)	
	(command "extrude" e6 "" "p" caminho )
		(command "color" "bylayer")	
		
		;desenhar a janela 3
		(command "3dpoly"   (list (/ largura 3) 0.02 0)
						(list (/ largura 3) 0.02 2.7)
						(list (- (/ largura 1.55) 0.125) 0.02 2.7)
						(list (- (/ largura 1.55) 0.125) 0.02 0)
						"cl")
	(setq caminho (entlast))
	(command "rectangle" (list (+ (/ largura 3) 0.125) 0.02 0)
							(list (+ (/ largura 3) 0.175) 0.07 0)
							)
	(setq e6 (entlast))
		(command "color" 5)	
	(command "extrude" e6 "" "p" caminho )
		(command "color" "bylayer")


	
	
	;adicionar parede 
	(command "rectangle" (list (alea (* largura 0.66) (* largura 0.70))
							(setq val2 (alea (* comprimento 0.3) (* comprimento 0.80)))) 
						 (list (- largura 0.2) (+ val2 0.10))
						 )
	(reg)
	(setq e5 (entlast))	
	
	
	;unir as paredes
	(command "union" wc paredes e5 "")	
	
	
	;desenha a altura das paredes
	(ext 2.6)
	
;unir as paredes
(command "union" wc paredes e5 e7 e8 "")
	
	

	;;;terminar função T1
	(command "ucs" "")

	(setvar "osmode" pontos2d)
	(setvar "3dosmode" pontos3d)
)

(defun reg ()
	(command "region" (entlast) "")
)
(defun ext (ex)
		(command "extrude" (entlast) "" ex)	
)

(defun alea ( min max / )
	(+ min (valor (- max min)))
)
(defun valor ( num / )
	(* num (rnd))
)
(defun rnd (/ modulus multiplier increment random)
  (if (not seed)
    (setq seed (getvar "DATE"))
  )
  (setq modulus    65536
        multiplier 25173
        increment  13849
        seed  (rem (+ (* multiplier seed) increment) modulus)
        random     (/ seed modulus)
  )
)
